Code

Prepare for 1.7.6.6
[git.git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places.  If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
14 git_broken_path_fix () {
15         case ":$PATH:" in
16         *:$1:*) : ok ;;
17         *)
18                 PATH=$(
19                         SANE_TOOL_PATH="$1"
20                         IFS=: path= sep=
21                         set x $PATH
22                         shift
23                         for elem
24                         do
25                                 case "$SANE_TOOL_PATH:$elem" in
26                                 (?*:/bin | ?*:/usr/bin)
27                                         path="$path$sep$SANE_TOOL_PATH"
28                                         sep=:
29                                         SANE_TOOL_PATH=
30                                 esac
31                                 path="$path$sep$elem"
32                                 sep=:
33                         done
34                         echo "$path"
35                 )
36                 ;;
37         esac
38 }
40 # @@BROKEN_PATH_FIX@@
42 die() {
43         echo >&2 "$@"
44         exit 1
45 }
47 GIT_QUIET=
49 say () {
50         if test -z "$GIT_QUIET"
51         then
52                 printf '%s\n' "$*"
53         fi
54 }
56 if test -n "$OPTIONS_SPEC"; then
57         usage() {
58                 "$0" -h
59                 exit 1
60         }
62         parseopt_extra=
63         [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64                 parseopt_extra="--keep-dashdash"
66         eval "$(
67                 echo "$OPTIONS_SPEC" |
68                         git rev-parse --parseopt $parseopt_extra -- "$@" ||
69                 echo exit $?
70         )"
71 else
72         dashless=$(basename "$0" | sed -e 's/-/ /')
73         usage() {
74                 die "Usage: $dashless $USAGE"
75         }
77         if [ -z "$LONG_USAGE" ]
78         then
79                 LONG_USAGE="Usage: $dashless $USAGE"
80         else
81                 LONG_USAGE="Usage: $dashless $USAGE
83 $LONG_USAGE"
84         fi
86         case "$1" in
87                 -h|--h|--he|--hel|--help)
88                 echo "$LONG_USAGE"
89                 exit
90         esac
91 fi
93 set_reflog_action() {
94         if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95         then
96                 GIT_REFLOG_ACTION="$*"
97                 export GIT_REFLOG_ACTION
98         fi
99 }
101 git_editor() {
102         if test -z "${GIT_EDITOR:+set}"
103         then
104                 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
105         fi
107         eval "$GIT_EDITOR" '"$@"'
110 git_pager() {
111         if test -t 1
112         then
113                 GIT_PAGER=$(git var GIT_PAGER)
114         else
115                 GIT_PAGER=cat
116         fi
117         : ${LESS=-FRSX}
118         export LESS
120         eval "$GIT_PAGER" '"$@"'
123 sane_grep () {
124         GREP_OPTIONS= LC_ALL=C grep "$@"
127 sane_egrep () {
128         GREP_OPTIONS= LC_ALL=C egrep "$@"
131 is_bare_repository () {
132         git rev-parse --is-bare-repository
135 cd_to_toplevel () {
136         cdup=$(git rev-parse --show-toplevel) &&
137         cd "$cdup" || {
138                 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
139                 exit 1
140         }
143 require_work_tree_exists () {
144         if test "z$(git rev-parse --is-bare-repository)" != zfalse
145         then
146                 die "fatal: $0 cannot be used without a working tree."
147         fi
150 require_work_tree () {
151         test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
152         die "fatal: $0 cannot be used without a working tree."
155 require_clean_work_tree () {
156         git rev-parse --verify HEAD >/dev/null || exit 1
157         git update-index -q --ignore-submodules --refresh
158         err=0
160         if ! git diff-files --quiet --ignore-submodules
161         then
162                 echo >&2 "Cannot $1: You have unstaged changes."
163                 err=1
164         fi
166         if ! git diff-index --cached --quiet --ignore-submodules HEAD --
167         then
168                 if [ $err = 0 ]
169                 then
170                     echo >&2 "Cannot $1: Your index contains uncommitted changes."
171                 else
172                     echo >&2 "Additionally, your index contains uncommitted changes."
173                 fi
174                 err=1
175         fi
177         if [ $err = 1 ]
178         then
179                 test -n "$2" && echo >&2 "$2"
180                 exit 1
181         fi
184 get_author_ident_from_commit () {
185         pick_author_script='
186         /^author /{
187                 s/'\''/'\''\\'\'\''/g
188                 h
189                 s/^author \([^<]*\) <[^>]*> .*$/\1/
190                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
192                 g
193                 s/^author [^<]* <\([^>]*\)> .*$/\1/
194                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
196                 g
197                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
198                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
200                 q
201         }
202         '
203         encoding=$(git config i18n.commitencoding || echo UTF-8)
204         git show -s --pretty=raw --encoding="$encoding" "$1" -- |
205         LANG=C LC_ALL=C sed -ne "$pick_author_script"
208 # Clear repo-local GIT_* environment variables. Useful when switching to
209 # another repository (e.g. when entering a submodule). See also the env
210 # list in git_connect()
211 clear_local_git_env() {
212         unset $(git rev-parse --local-env-vars)
215 # Make sure we are in a valid repository of a vintage we understand,
216 # if we require to be in a git repository.
217 if test -z "$NONGIT_OK"
218 then
219         GIT_DIR=$(git rev-parse --git-dir) || exit
220         if [ -z "$SUBDIRECTORY_OK" ]
221         then
222                 test -z "$(git rev-parse --show-cdup)" || {
223                         exit=$?
224                         echo >&2 "You need to run this command from the toplevel of the working tree."
225                         exit $exit
226                 }
227         fi
228         test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
229                 echo >&2 "Unable to determine absolute path of git directory"
230                 exit 1
231         }
232         : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
233 fi
235 # Fix some commands on Windows
236 case $(uname -s) in
237 *MINGW*)
238         # Windows has its own (incompatible) sort and find
239         sort () {
240                 /usr/bin/sort "$@"
241         }
242         find () {
243                 /usr/bin/find "$@"
244         }
245         is_absolute_path () {
246                 case "$1" in
247                 [/\\]* | [A-Za-z]:*)
248                         return 0 ;;
249                 esac
250                 return 1
251         }
252         ;;
253 *)
254         is_absolute_path () {
255                 case "$1" in
256                 /*)
257                         return 0 ;;
258                 esac
259                 return 1
260         }
261 esac